########### BEGIN TOOLS ###############
HOST = LITTLE_ENDIAN
BGI = YES
#==================================  Begin BASE =========================================
#define VIRTUOSO root directory
ifdef ADI21020DIR
VIRTUOSO_DIR = $(subst \,/,$(ADI21020DIR))
else
VIRTUOSO_DIR = $(subst \,/,$(VIRTDIR))/ADI21020
endif

#define ADI root directory
ADI_DIR = $(subst \,/,$(ADI_DSP))

#define some commonly used operations
RM	 = cmd /c del /q
CP	 = cmd /c copy
MV	 = cmd /c ren
DIRCMD = cmd /c dir
CLR_RD_ONLY = attrib -r

#define tools
##ifeq ($(WIN),WINXP)
##----------> Per Win XP
CC	= $(ADI_DIR)/bin/g21k
AS	= $(ADI_DIR)/bin/asm21k
AR	= $(ADI_DIR)/bin/lib21k
LN	= $(ADI_DIR)/bin/ld21k
MEM = $(ADI_DIR)/bin/mem21k
CDMP= $(ADI_DIR)/bin/cdump

##else
##----------> Per Win NT
##CC	= conspawn $(ADI_DIR)/bin/g21k
##AS	= conspawn $(ADI_DIR)/bin/asm21k
##AR	= conspawn $(ADI_DIR)/bin/lib21k
##LN	= conspawn $(ADI_DIR)/bin/ld21k
##MEM = conspawn $(ADI_DIR)/bin/mem21k
##CDMP = conspawn $(ADI_DIR)/bin/cdump
##endif

ARFLAGS = -c -i ofiles.lst
LNFLAGS =


#define rules for making objects
%.o : %.c  cflags
	$(CC) @cflags -o $@ $<

%.o : %.C  cflags
	$(CC) @cflags -o $@ $<

%.o : %.s
	$(AS) $(ASFLAGS) -o $@ $<

%.o : %.S
	$(AS) $(ASFLAGS) -o $@ $<


#define path to include and lib directories
INCS = -I$(VIRTUOSO_DIR)/inc -I$(SOURCEPATH) -I.
LIBS = $(VIRTUOSO_DIR)/lib.r33

#define required libraries
RTLIBS = $(ADI_DIR)/21k/lib/libc.a
HDROBJ = $(LIBS)/020_hdr.o

STDIOLIB   = $(LIBS)/stdio.a
GRAPHLIB   = $(LIBS)/bgi.a
BASELIB    = $(LIBS)/hostio.a
CONIOLIB   = $(LIBS)/conio.a

ifeq ($(SMCSDRV),MOSAIC020)
SMCSLIB    = $(LIBS)/smcs_gen.a
HOSTLIB    = $(LIBS)/smcs_hos.a
RAWLIB	   = $(LIBS)/smcs_raw.a
NETLIB	   = $(LIBS)/smcs_net.a
endif

ifeq ($(SMCSDRV),VIRTIS)
SMCSLIB    = $(LIBS)/svrt_gen.a
HOSTLIB    = $(LIBS)/svrt_hos.a
RAWLIB	   = $(LIBS)/svrt_raw.a
NETLIB	   = $(LIBS)/svrt_net.a
endif

ifeq ($(KERNEL),REGULAR)
VIRTLIB    = $(LIBS)/virtos.a
TIMERLIB   = $(LIBS)/timer.a
STACKLIB   = $(LIBS)/stackh.a
endif

ifeq ($(KERNEL),DEBUG)
VIRTLIB   = $(LIBS)/virtosd.a
TIMERLIB   = $(LIBS)/timer.a
STACKLIB   = $(LIBS)/stackh.a
endif

ifeq ($(KERNEL),SP)
VIRTLIB    = $(LIBS)/virtsp.a
TIMERLIB   = $(LIBS)/timer.a
STACKLIB   = $(LIBS)/stackh.a
endif

ifeq ($(KERNEL),SPDEBUG)
VIRTLIB   = $(LIBS)/virtspd.a
TIMERLIB   = $(LIBS)/timer.a
STACKLIB   = $(LIBS)/stackh.a
endif

ifeq ($(KERNEL),POWERSAVE)
VIRTLIB    = $(LIBS)/virtpow.a
TIMERLIB   = $(LIBS)/timerpow.a
STACKLIB   = $(LIBS)/stackpow.a
endif

ifeq ($(KERNEL),POWERDEBUG)
VIRTLIB   = $(LIBS)/virtpowd.a
TIMERLIB   = $(LIBS)/timerpow.a
STACKLIB   = $(LIBS)/stackpow.a
endif

ifeq ($(KERNEL),SPPOWERSAVE)
VIRTLIB    = $(LIBS)/virsppow.a
TIMERLIB   = $(LIBS)/timerpow.a
STACKLIB   = $(LIBS)/stackpow.a
endif

ifeq ($(KERNEL),SPPOWERDEBUG)
VIRTLIB   = $(LIBS)/virspowd.a
TIMERLIB   = $(LIBS)/timerpow.a
STACKLIB   = $(LIBS)/stackpow.a
endif

# by nino
#ifeq ($(HOST),BIG_ENDIAN)
#PACKLIB 	= $(LIBS)/strcnvbe.a
#else
#PACKLIB 	= $(LIBS)/strcnvle.a
#endif


#define 'all libs'
ALLIBS	   = $(STDIOLIB) $(GRAPHLIB) $(CONIOLIB) \
			 $(TIMERLIB) $(STACKLIB) $(PACKLIB)


#define how objects look like.
# elenca tutti gli *.o costruiti sostituendo s/c con o
# Richiesti come dipendenza in task.a, inserito in DEPENDENCIES
# richiesto come dipendenza in PROJECT. In definitiva e' questo
# che provoca la compilazione di tutti i file .c e .s in current
# dir ed SOURCEPATH.
SOBJECTS = $(patsubst %.s, %.o,$(wildcard *.s)) $(patsubst %.S, %.o,$(wildcard *.S)) $(patsubst %.s, %.o,$(wildcard $(SOURCEPATH)/*.s)) $(patsubst %.S, %.o,$(wildcard $(SOURCEPATH)/*.S))
COBJECTS = $(patsubst %.c, %.o,$(wildcard *.c)) $(patsubst %.C, %.o,$(wildcard *.C)) $(patsubst %.c, %.o,$(wildcard $(SOURCEPATH)/*.c)) $(patsubst %.C, %.o,$(wildcard $(SOURCEPATH)/*.C))

#base clean...
baseclean:
	$(RM) *.o
	$(RM) *.a
	$(RM) sysdef.new
	$(RM) *.lnk
	$(RM) *.pp
	$(RM) *.lst
	$(RM) *.log
	$(RM) *.ex0
	$(RM) *.fi0
	$(RM) *.fi1
	$(RM) cflags
	$(RM) automake

	

#baseveryclean...
baseveryclean:
	$(RM) node*.?
	$(RM) allnodes.h
	$(RM) $(PROJECT).exe

#dbgclean...
dbgclean:
	$(RM) *.ids
	$(RM) *.map

ifeq ($(KERNEL),REGULAR)
clean:	baseclean dbgclean
veryclean:	clean baseveryclean
endif

ifeq ($(KERNEL),SP)
clean:	baseclean dbgclean
veryclean:	clean baseveryclean
endif

ifeq ($(KERNEL),POWERSAVE)
clean:	baseclean dbgclean
veryclean:	clean baseveryclean
endif

ifeq ($(KERNEL),SPPOWERSAVE)
clean:	baseclean dbgclean
veryclean:	clean baseveryclean
endif

ifeq ($(KERNEL),DEBUG)
clean:	baseclean
veryclean:	clean dbgclean baseveryclean
endif

ifeq ($(KERNEL),SPDEBUG)
clean:	baseclean
veryclean:	clean dbgclean baseveryclean
endif

ifeq ($(KERNEL),POWERDEBUG)
clean:	baseclean
veryclean:	clean dbgclean baseveryclean
endif

ifeq ($(KERNEL),SPPOWERDEBUG)
clean:	baseclean
veryclean:	clean dbgclean baseveryclean
endif

#define example directory
EXAMPLE_DIR = ../../../../sources

# Crea la libreria task.a. Ricordo che ARFLAGS = -c -i ofiles.lst
task.a: allnodes.h $(filter-out node%.o,$(filter-out NODE%.o,$(notdir $(COBJECTS)))) $(notdir $(SOBJECTS))
	cmd /c dir *.o /s /b > ofiles.lst
	$(AR) $(ARFLAGS) task.a
	$(RM) ofiles.lst

## erano sotto task.a. Giovanni?????
#	echo paco > task.a
#	$(RM) task.a


# Qui genera testn.lnk con la lista delle librerie da caricare 
# con i NODEn.o
test%.lnk: makefile tools.mak $(VIRTUOSO_DIR)/rev33/base
	@echo $(HDROBJ) 				>  $@
	@echo NODE$*.o					>> $@
	@echo task.a					>> $@
	@echo $(GRAPHLIB)				>> $@
	@echo $(CONIOLIB)				>> $@
	@echo $(STDIOLIB)				>> $@
	@echo $(BASELIB)				>> $@
	@echo $(HOSTLIB)				>> $@
	@echo $(TIMERLIB)				>> $@
	@echo $(STACKLIB)				>> $@
ifeq ($(SMCSDRV),MOSAIC020)
	@echo $(SMCSLIB)				>> $@
	@echo $(RAWLIB) 				>> $@
	@echo $(NETLIB) 				>> $@
endif
ifeq ($(SMCSDRV),VIRTIS)
	@echo $(SMCSLIB)				>> $@
	@echo $(RAWLIB) 				>> $@
	@echo $(NETLIB) 				>> $@
endif
	@echo $(VIRTLIB)				>> $@
ifdef FFTCLIB
	@echo $(FFTCLIB)				>> $@
endif
ifdef VECTCLIB
	@echo $(VECTCLIB)				>> $@
endif
ifdef SIGNALLIB
	@echo $(SIGNALLIB)				>> $@
endif
ifdef MOD0LIB
	@echo $(MOD0LIB)				>> $@
endif
ifdef MATRCLIB
	@echo $(MATRCLIB)				>> $@
endif
	@echo $(RTLIBS) 				>> $@
	@echo $(HDROBJ) 				>> $@
	@echo NODE$*.o					>> $@
	@echo task.a					>> $@
	@echo $(GRAPHLIB)				>> $@
	@echo $(CONIOLIB)				>> $@
	@echo $(STDIOLIB)				>> $@
	@echo $(BASELIB)				>> $@
# by nino	@echo $(PACKLIB)				>> $@
	@echo $(HOSTLIB)				>> $@
	@echo $(TIMERLIB)				>> $@
	@echo $(STACKLIB)				>> $@
ifeq ($(SMCSDRV),MOSAIC020)
	@echo $(SMCSLIB)				>> $@
	@echo $(RAWLIB) 				>> $@
	@echo $(NETLIB) 				>> $@
endif
ifeq ($(SMCSDRV),VIRTIS)
	@echo $(SMCSLIB)				>> $@
	@echo $(RAWLIB) 				>> $@
	@echo $(NETLIB) 				>> $@
endif
	@echo $(VIRTLIB)				>> $@
	@echo NODE$*.o					>> $@
ifdef FFTCLIB
	@echo $(FFTCLIB)				>> $@
endif
ifdef VECTCLIB
	@echo $(VECTCLIB)				>> $@
endif
ifdef SIGNALLIB
	@echo $(SIGNALLIB)				>> $@
endif
ifdef MOD0LIB
	@echo $(MOD0LIB)				>> $@
endif
ifdef MATRCLIB
	@echo $(MATRCLIB)				>> $@
endif
	@echo $(RTLIBS) 				>> $@

#define project file (only one should exist in the current dir !!!)
VPFILE = $(strip $(wildcard *.vpf) $(wildcard *.VPF))

#define NLI file (only one should exist in the current dir !!!)
NLIFILE = $(strip $(wildcard *.nli) $(wildcard *.NLI))


#define additional sources search path
VPATH = $(SOURCEPATH)


#define how to make the compiler option file 'cflags'
cflags: makefile tools.mak $(VIRTUOSO_DIR)/rev33/base
	@echo $(CCFLAGS) > cflags

#define project file (only one should exist in the current dir !!!

#define general dependencies for executable
DEPENDENCIES = tools.mak $(VIRTUOSO_DIR)/rev33/base task.a $(ALLIBS) allnodes.h configura.h

#define .PRECIOUS target. These files are not deleted as intermediates
.PRECIOUS: NODE%.c


#============================================  End Base ===========================================
#define required libraries
HOSTLIB = $(LIBS)/bwrsgen.a

########### END TOOLS ###############

